//*************************
//* TILES.C 1.0 ws 3/2017 *
//*************************

#include <stdio.h>
#include <string.h>

long filesize(char *fname);
void waitkey(void);

int main(int argc, char **argv)
{
	FILE *in;
	FILE *out;
	unsigned int x, y, z;
    unsigned long fs, lines, chars;
    char outfile[20];
    char *filename, *name, *ext;
    unsigned char bmphead[1078];
    unsigned char bmpdata[1024][8];
	
    filename = strupr(argv[1]);

  	printf("TILES 1.0 ws 3/2017\n\n");

	if(argc < 2) {
    	printf("No File specified !!!\n\n");
        waitkey();
        return -1;
    }

    if(!strstr(filename,".BMP")) {  
    	printf("File has no .BMP Extension !!!\n\n");
        waitkey();
        return -2;
    }

	in = fopen(filename, "rb");
	if(!in) {
    	printf("File not found !!!\n\n");
        waitkey();
        return -3;
    }

    fs = filesize(filename) - 1078;
    lines = fs / 8;
    chars = lines / 8;

    if ((fs & 64) != 0) {
    	printf("ERROR! BMP must have multiple Heith of 8.\n\n");
        waitkey();
        return -4;
    }    
    
    name = strtok(filename, ".");
    ext = strtok(NULL, ".");
    strcpy(outfile,name);
    strcat(outfile,".TXT");

	for(x = 0 ; x<1078 ; x++) {
		bmphead[x] = fgetc(in);
    }

    if((int)bmphead[0] != 66  || (int)bmphead[1] != 77) {
    	printf("File has no BMP-Header !!!\n\n");
        waitkey();
        return -5;
    }

    if((int)bmphead[18] != 8) {
    	printf("BMP must have 8 Pixel Width !!!\n\n");
        waitkey();
        return -6;
    }

    printf("%i\r\n", lines);  
    printf("%i\r\n", chars);  


	for(x = 0 ; x<lines ; x++) {
        z = (lines-1)-x;
        for(y = 0 ; y<8 ; y++) {
            bmpdata[z][y] = fgetc(in);
        }
    }
    fclose(in);

	out = fopen(outfile, "wb");
    for(x = 0 ; x<chars ; x++) {

        fprintf(out, "%s\r\n", "        '' name=''");  
        for(y = 0 ; y<8 ; y++) {
            fprintf(out, "%s", "        long    $");  
            for(z = 0 ; z<8 ; z++) {
                fprintf(out, "%1X", bmpdata[x*8+y][z]);  
            }
            fprintf(out,"\r\n");  
        }
        fprintf(out,"\r\n");  
    }

    fclose(out);
  	printf("File %s is created.\n\n", outfile);
    waitkey();
    return 0;
}



long filesize(char *fname)
{
    FILE *fp ;
    long size =0L;     

    fp = fopen(fname, "rb");
    fseek(fp, 0, SEEK_END); 
    size = ftell(fp);       
    fclose(fp); 
    return size;
}     




void waitkey()
{
	int k;
    printf("Press any Key to continue...");
	k = getch();
    printf("\n");
}


